#pragma once

//#define _WIN32_DCOM
//#include <comdef.h>
//#include <Wbemidl.h>
//# pragma comment(lib, "wbemuuid.lib")

class WMIObject
{
	IWbemClassObject *cls_obj_ptr_;

public:
	WMIObject(IWbemClassObject *);
	HRESULT get(wchar_t const *name, VARIANT *val_ptr);
};

class WMIObjectSet
	: public std::iterator<std::input_iterator_tag, WMIObject>
{
	IEnumWbemClassObject *enumerator_ptr_;
	IWbemClassObject *cls_obj_ptr_;

	void next();

public:
	WMIObjectSet();
	WMIObjectSet(IEnumWbemClassObject *enum_ptr);
	~WMIObjectSet();
	WMIObject operator*();
	//IWbemClassObject * operator->();
	WMIObjectSet & operator++();
	bool operator!=(WMIObjectSet const &crh) const;

	// noncopyable
private:
	WMIObjectSet(WMIObjectSet const &);
	WMIObjectSet const & operator=(WMIObjectSet const &);
};

class WMIService
{
	IWbemLocator *loc;
	IWbemServices *svc;

public:
	WMIService(wchar_t const *obj_name);
	~WMIService();
	IEnumWbemClassObject * execQuery(wchar_t const *wql);

	// noncopyable
private:
	WMIService(WMIService const &);
	WMIService const & operator=(WMIService const &);
};
