#ifndef INF_FILE_H__B8A7DAEF_143E_4709_AEB5_459DC214C6AA__INCLUDED
#define INF_FILE_H__B8A7DAEF_143E_4709_AEB5_459DC214C6AA__INCLUDED
// M$ compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

/////////////////////////////////////////////////////////////////////////////
// InfFile.h
//  H20(2008)/02/25 쐬
//  H22(2010)/05/02 SP_INF_INFORMATION\̂QƂAPI̔r
//                  (INFt@C̃pXƈُȒlԂƂ邽)
// Classes in this file:
//  InfContext
//  InfContextIterator
//  InfFile
/////////////////////////////////////////////////////////////////////////////

#include "exception.h"

namespace MyLib {
//=======================================================================
// InfContext
//	INFt@ĆAP̍s̃ReLXg
//=======================================================================
class InfContext
	: public INFCONTEXT
{
public:
	InfContext();
	//
	// getFieldCount
	//	INF t@C̎w肳ꂽsɊ܂܂ĂtB[h̐擾܂B
	// ߂lF
	//	s̃tB[hB
	//
	unsigned int getFieldCount(void);

	//
	// getIntField
	//	INF t@C̓̍s̎w肳ꂽtB[h琮l擾܂B
	// ߂lF
	//	擾l
	// F
	//	field_index		- tB[h̃CfbNXԍ
	//
	int getIntField(unsigned int field_index);

	//
	// getStringField
	//	w肳ꂽtB[h̒l𕶎ƂĎ擾B
	// ߂lF
	//	擾
	// F
	//	field_index	- tB[h̃CfbNXԍ
	//
	std::wstring getStringField(unsigned int field_index);

	//
	// getBinaryField
	//	INF t@C̃ZNV̓̍sAoCif[^擾܂B
	//	w肳ꂽtB[h炻̍s̍s܂ł̃f[^o܂B
	// ߂lF
	//	擾oCif[^
	// F
	//	field_index	- JntB[h̃CfbNXԍ
	//
	std::vector<char> getBinaryField(unsigned int field_index);

	//
	// getMultiSzField
	//	INF t@C̓̍sɋL^Ă镡̕擾܂B
	//	w肳ꂽtB[hs܂ł̃tB[h擾܂B
	// ߂lF
	//	擾̕
	// F
	//	field_index	- JntB[h̃CfbNXԍ
	//
	std::vector<std::wstring> getMultiSzField(unsigned int field_index);

	//
	// getLineText
	//	INF t@C 1 ̍s̓eRpNgȌ`ŕԂ܂B
	// ߂lF
	//	s̃eLXg
	//
	std::wstring getLineText();

	bool operator ==(const InfContext& rhs) const;

	operator PINFCONTEXT();
};

inline InfContext::InfContext()
{
	this->Inf = NULL;
	this->CurrentInf = NULL;
	this->Section = 0;
	this->Line = 0;
}

inline unsigned int InfContext::getFieldCount()
{
	unsigned int ret = ::SetupGetFieldCount(this);
	if (ret == 0) {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return ret;
}

inline int InfContext::getIntField(unsigned int field_index)
{
	int return_value;
	if (!::SetupGetIntField(this, field_index, &return_value)) {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return return_value;
}

inline std::wstring InfContext::getStringField(unsigned int field_index)
{
	std::wstring result;
	DWORD required_count;
	// Kvȃobt@TCY擾
	const bool ret1 = (::SetupGetStringField(
		this, field_index, NULL, 0, &required_count) != 0);
	if (ret1) {
		if (required_count > 0) {
			// obt@m
			boost::scoped_array<wchar_t> buf(new wchar_t[required_count]);
			const bool ret2 = (::SetupGetStringField(this, field_index,
				buf.get(), required_count, NULL) != 0);
			if (!ret2) {
				//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
				BOOST_THROW_EXCEPTION(SetupAPIException());
			}
			result = buf.get();
		}
	} else {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return result;
}

inline std::vector<char> InfContext::getBinaryField(unsigned int field_index)
{
	std::vector<char> result;
	DWORD required_size;
	const bool ret1 = (::SetupGetBinaryField(
		this, field_index, NULL, 0, &required_size) != 0);
	if (ret1) {
		if (required_size > 0) {
			result.resize(required_size);
			const bool ret2 = (::SetupGetBinaryField(this, field_index,
				reinterpret_cast<BYTE*>(&result[0]), required_size, NULL) != 0);
			if (!ret2) {
				//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
				BOOST_THROW_EXCEPTION(SetupAPIException());
			}
		}
	} else {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return result;
}

inline std::vector<std::wstring> InfContext::getMultiSzField(unsigned int field_index)
{
	std::vector<std::wstring> result;
	DWORD required_count;
	const bool ret1 = (::SetupGetMultiSzField(
		this, field_index, NULL, 0, &required_count) != 0);
	if (ret1) {
		if (required_count > 0) {
			boost::scoped_array<wchar_t> buf(new wchar_t[required_count]);
			const bool ret2 = (::SetupGetMultiSzField(this, field_index,
				buf.get(), required_count, NULL) != 0);
			if (!ret2) {
				//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
				BOOST_THROW_EXCEPTION(SetupAPIException());
			}
			// obt@當o
			LPTSTR ptr = buf.get();//&buf[0];
			size_t n = ::_tcslen(ptr);
			while (n > 0) {
				result.push_back(ptr);
				ptr += n + 1;
				n = ::_tcslen(ptr);
			}
		}
	} else {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return result;
}

inline std::wstring InfContext::getLineText(void)
{
	uint32_t required_count;
	std::vector<TCHAR> buf;
	const bool ret1 = (::SetupGetLineText(
		this, NULL, NULL, NULL, NULL, 0, reinterpret_cast<DWORD*>(&required_count)) != FALSE);
	if (ret1) {
		buf.resize(required_count);
		const bool ret2 = (::SetupGetLineText(this, NULL, NULL, NULL,
			&buf.front(), required_count, NULL) != FALSE);
		if (!ret2) {
			//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
			BOOST_THROW_EXCEPTION(SetupAPIException());
		}
	} else {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return &buf.front();
}

inline bool InfContext::operator ==(const InfContext& rhs) const
{
	return this->Inf == rhs.Inf
		&& this->CurrentInf == rhs.CurrentInf
		&& this->Section == rhs.Section
		&& this->Line == rhs.Line;
}

inline InfContext::operator PINFCONTEXT()
{
	return this;
}

//=======================================================================
// InfContextIterator
//  Ce[^
//=======================================================================
class InfContextIterator
	: std::iterator<std::forward_iterator_tag, InfContext>
{
	value_type value;
	typedef InfContextIterator this_type;
public:
	// ftHgRXgN^
	//  ŐꂽCX^XI[Ƃ݂ȂB
	InfContextIterator(void)
	{
	}
	// RXgN^
	InfContextIterator(const value_type& context)
		: value(context)
	{
	}
	// InfContextNX̎QƂԂ
	reference operator*(void)
	{
		return this->value;
	}
	// |C^ƓlɃANZXł悤ɂ
	pointer operator->(void)
	{
		return &this->value;
	}
	// OuCNgZq
	const this_type& operator++(void)
	{
		if (!::SetupFindNextLine(value, value)) {
			// I[Ƃ
			this->value = InfContext();
		}
		return *this;
	}
	// uCNgZq
	this_type operator++(int)
	{
		this_type tmp = *this;
		++*this;
		return tmp;
	}
	// rZq
	bool operator==(const this_type& rhs) const
	{
		return this->value == rhs.value;
	}
	bool operator!=(const this_type& rhs) const
	{
		return !(*this == rhs);
	}
};

//=======================================================================
// InfFile
//	INFt@C̉(ǂݍݐp)
//=======================================================================
class InfFile
{
public:
	InfFile(boost::filesystem::wpath const &filename);
	~InfFile(void);
protected:
	//
	// open
	//	INFt@CJ
	// ߂lF
	//	G[R[h
	// F
	//	filename	- INFt@C
	//	error_line	- G[ꍇA
	//              - ̍sԍ󂯎ϐ̃|C^(ȗ)
	//
	HRESULT open(boost::filesystem::wpath const &filename, unsigned int *error_line = NULL);

	//
	// close
	//	INFt@C
	//
	void close(void);
public:
	//
	// findFirstLine
	//  INF t@C̎w肳ꂽZNV̓̍s܂B
	// ߂lF
	//  s̃Ce[^B
	// F
	//  section - Ɏg INF t@C̃ZNVB
	//  key     - ZNV̌L[B
	//            ȗꍇÃZNV̍ŏ̍sԂ܂B
	//
	InfContextIterator findFirstLine(LPCTSTR section, LPCTSTR key = NULL);

	//
	// findNextMatchLine
	//  Ce[^ƂāAINF t@C̃ZNVŁA
	//  w肳ꂽL[Ɉv鎟̍s̃Ce[^Ԃ܂B
	// ߂lF
	//  s̃Ce[^B
	// F
	//  it      - Ƃs̃Ce[^B
	//  key     - ZNV̌L[B
	//            w肳ꂽL[Ɉv鎟̍s̃Ce[^Ԃ܂B
	//            ȗꍇAZNV̎̍sԂ܂B
	//
	InfContextIterator findNextMatchLine(
		InfContextIterator it, LPCTSTR key = NULL);

	//
	// GetLineCount
	//	INF t@C̎w肳ꂽZNV̍sԂ܂B
	// ߂lF
	//	0 ԂꍇAZNVłƂӖ܂B
	//	ZNV݂ȂꍇA-1 Ԃ܂B
	// F
	//	section	- ZNV
	//
	int getLineCount(LPCTSTR section);

	//
	// getLineText
	//	INF t@C 1 ̍s̓eRpNgȌ`ŕԂ܂B
	// ߂lF
	//	s̃eLXg
	// F
	//	section		: ZNV
	//	key			: L[
	//
	std::wstring getLineText(LPCTSTR section, LPCTSTR key);

	std::wstring getFullPathName(void);
	std::wstring getVersionInfo(LPCTSTR key);

	boost::filesystem::wpath getTargetPath(LPCTSTR file_list_section = NULL);

	operator HINF(void) const;

protected:
	HINF inf_handle;
	//PSP_INF_INFORMATION inf_info_ptr;
	boost::filesystem::wpath inf_full_path;

	//HRESULT getInfInformation(void);
};

inline InfFile::InfFile(boost::filesystem::wpath const &filename)
: inf_handle(INVALID_HANDLE_VALUE)
//, inf_info_ptr(NULL)
{
	HRESULT ret;
	//unsigned int n;
	ret = this->open(filename);//, &n);
	if (FAILED(ret)) {
		//throw MY_SETUP_API_FILE_EXCEPTION(filename, ret);
		BOOST_THROW_EXCEPTION(SetupAPIException(ret));
	}
	//ret = this->getInfInformation();
	//if (FAILED(ret)) {
	//	this->close();
	//	throw MY_SETUP_API_FILE_EXCEPTION(filename, ret);
	//}
}

inline InfFile::~InfFile(void)
{
	this->close();
}

inline HRESULT InfFile::open(boost::filesystem::wpath const &filename, unsigned int *error_line)
{
	assert(this->inf_handle == INVALID_HANDLE_VALUE);
	namespace fs = boost::filesystem;
	fs::wpath const file_path = filename;
	std::wstring const file_path_str = file_path.wstring();
	if (file_path_str.find(L'\\') == std::wstring::npos) {
		// If the filename does not contain path separator characters,
		// it is searched for, first in the %windir%\inf directory,
		// and then in the %windir%\system32 directory.
		wchar_t windir_path_buf[MAX_PATH + 1];
		::GetWindowsDirectory(windir_path_buf, MAX_PATH);
		fs::wpath const windir_path = windir_path_buf;
		fs::wpath const in_inf_dir_path = windir_path/L"inf"/file_path;
		if (fs::exists(in_inf_dir_path)) {
			this->inf_full_path = in_inf_dir_path;
		} else {
			fs::wpath const in_system32_dir_path = windir_path/L"system32"/file_path;
			if (fs::exists(in_system32_dir_path)) {
				this->inf_full_path = in_system32_dir_path;
			} else {
				return HRESULT_FROM_WIN32(ERROR_FILE_NOT_FOUND);
			}
		}
	} else {
		// If the filename contains path separator characters,
		// it is assumed to be a full path specification and no further processing is performed on it.
		this->inf_full_path = file_path;
	}

	HRESULT ret = S_OK;
	const HINF inf_handle =
		::SetupOpenInfFile(this->inf_full_path.c_str(), NULL, INF_STYLE_WIN4, error_line);
	if (inf_handle != INVALID_HANDLE_VALUE) {
		this->inf_handle = inf_handle;
		//this->inf_full_path = fs::system_complete(fs::wpath(filename));
	} else {
		ret = getSetupAPILastError();
	}
	return ret;
}

inline void InfFile::close(void)
{
	if (this->inf_handle != INVALID_HANDLE_VALUE) {
		::SetupCloseInfFile(this->inf_handle);
		this->inf_handle = INVALID_HANDLE_VALUE;
	}
	//// deleteNULL|C^nꂽꍇȂ
	//delete[] this->inf_info_ptr;
	//this->inf_info_ptr = NULL;
}

inline InfContextIterator InfFile::findFirstLine(LPCTSTR section, LPCTSTR key)
{
	InfContext context;
	const bool ret = (::SetupFindFirstLine(
		this->inf_handle, section, key, context) != FALSE);
	if (!ret) {
		const HRESULT err_code = getSetupAPILastError();
		// uINF ɕKvȍs܂łBvȊÕG[
		if (err_code != HRESULT_FROM_SETUPAPI(ERROR_LINE_NOT_FOUND)) {
			//throw MY_SETUP_API_EXCEPTION(err_code);
			BOOST_THROW_EXCEPTION(SetupAPIException(err_code));
		}
	}
	return InfContextIterator(context);
}

inline InfContextIterator InfFile::findNextMatchLine(
	InfContextIterator it, LPCTSTR key)
{
	InfContext current_context = *it;
	InfContext new_context;
	const bool ret = (::SetupFindNextMatchLine(
		current_context, key, new_context) != FALSE);
	if (!ret) {
		const HRESULT err_code = getSetupAPILastError();
		if (err_code != HRESULT_FROM_SETUPAPI(ERROR_LINE_NOT_FOUND)) {
			// uINF ɕKvȍs܂łBvȊÕG[
			//throw MY_SETUP_API_EXCEPTION(err_code);
			BOOST_THROW_EXCEPTION(SetupAPIException(err_code));
		}
	}
	return InfContextIterator(new_context);
}

inline int InfFile::getLineCount(LPCTSTR section)
{
	assert(this->inf_handle != INVALID_HANDLE_VALUE);

	return ::SetupGetLineCount(this->inf_handle, section);
}

inline std::wstring InfFile::getLineText(LPCTSTR section, LPCTSTR key)
{
	assert(this->inf_handle != INVALID_HANDLE_VALUE);

	std::wstring result;
	DWORD required_size;
	const bool ret1 = (::SetupGetLineText(
		NULL, this->inf_handle, section, key, NULL, 0, &required_size) != 0);
	if (ret1) {
		if (required_size > 0) {
			std::vector<TCHAR> buf(required_size);
			const bool ret2 = (::SetupGetLineText(NULL, this->inf_handle,
				section, key, &buf.front(), required_size, NULL) != 0);
			if (!ret2) {
				//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
				BOOST_THROW_EXCEPTION(SetupAPIException());
			}
			result = &buf[0];
		}
	} else {
		//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
		BOOST_THROW_EXCEPTION(SetupAPIException());
	}
	return result;
}

inline InfFile::operator HINF(void) const
{
	return this->inf_handle;
}

inline std::wstring InfFile::getFullPathName(void)
{
	//std::wstring result;
	//DWORD required_count;
	//const bool ret1 = (::SetupQueryInfFileInformation(
	//	this->inf_info_ptr, 0, NULL, 0, &required_count) != 0);
	//if (ret1) {
	//	if (required_count > 0) {
	//		std::vector<TCHAR> buf(required_count);
	//		const bool ret2 = (::SetupQueryInfFileInformation(
	//			this->inf_info_ptr, 0, &buf.front(), required_count, NULL) != 0);
	//		if (!ret2) {
	//			throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
	//		}
	//		result = &buf[0];
	//	}
	//} else {
	//	throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
	//}
	//return result;
	//return this->inf_full_path.native_file_string();
	return this->inf_full_path.wstring();
}

inline std::wstring InfFile::getVersionInfo(LPCTSTR key)
{
	//std::wstring result;
	//DWORD required_count;
	//const bool ret1 = (::SetupQueryInfVersionInformation(
	//	this->inf_info_ptr, 0, key, NULL, 0, &required_count) != 0);
	//if (ret1) {
	//	if (required_count > 0) {
	//		std::vector<TCHAR> buf(required_count);
	//		const bool ret2 = (::SetupQueryInfVersionInformation(
	//			this->inf_info_ptr, 0, key, &buf.front(), required_count, NULL) != 0);
	//		if (!ret2) {
	//			throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
	//		}
	//		result = &buf[0];
	//	}
	//}
	//return result;
	const InfContextIterator inf_end;
	InfContextIterator ver_key_it =
		this->findFirstLine(_T("Version"), key);
	if (ver_key_it != inf_end) {
		return ver_key_it->getStringField(1);
	}
	return L"";
}

//inline HRESULT InfFile::getInfInformation(void)
//{
//	HRESULT result = S_OK;
//	DWORD required_count;
//	const bool ret1 = (::SetupGetInfInformation(this->inf_handle,
//		INFINFO_INF_SPEC_IS_HINF, NULL, 0, &required_count) != 0);
//	if (ret1) {
//		if (required_count > 0) {
//			this->inf_info_ptr =
//				reinterpret_cast<PSP_INF_INFORMATION>(new char[required_count]);
//			const bool ret2 = (::SetupGetInfInformation(
//				this->inf_handle, INFINFO_INF_SPEC_IS_HINF,
//				this->inf_info_ptr, required_count, NULL) != 0);
//			if (!ret2) {
//				result = getSetupAPILastError();
//			}
//		}
//	} else {
//		result = getSetupAPILastError();
//	}
//	return result;
//}

inline boost::filesystem::wpath InfFile::getTargetPath(LPCTSTR file_list_section)
{
	DWORD required_count = 0;
	const bool ret = (::SetupGetTargetPath(this->inf_handle, NULL,
		file_list_section, NULL, 0, &required_count) != 0);
	if (ret) {
		if (required_count > 1) {
			boost::scoped_array<wchar_t> buf(new wchar_t[required_count]);
			const bool ret2 = (::SetupGetTargetPath(this->inf_handle, NULL,
				file_list_section, buf.get(), required_count, NULL) != 0);
			if (ret2) {
				return buf.get();
			}
		}
		throw std::runtime_error("Target path not found");
	}
	//throw MY_SETUP_API_EXCEPTION_LAST_ERROR;
	BOOST_THROW_EXCEPTION(SetupAPIException());
}
};  // namespace MyLib

#endif	// INF_FILE_H__B8A7DAEF_143E_4709_AEB5_459DC214C6AA__INCLUDED
