#pragma once

#include "Exception.h"
#include "AutoHandle.h"

namespace MyLib {
class StorageDeviceNumber :
	private STORAGE_DEVICE_NUMBER
{
	void create(wchar_t const *device_name)
	{
		AutoHandleI ah = ::CreateFile(device_name,
		                              0,
		                              FILE_SHARE_READ | FILE_SHARE_WRITE,
		                              NULL,
		                              OPEN_EXISTING,
		                              0,
		                              NULL);
		if (ah.isInvalid()) {
			BOOST_THROW_EXCEPTION(Win32Exception());
		}

		STORAGE_DEVICE_NUMBER &sdn = *this;
		DWORD junk;
		BOOL ret = ::DeviceIoControl(ah.get(),
		                             IOCTL_STORAGE_GET_DEVICE_NUMBER,
		                             NULL,
		                             0,
		                             &sdn,
		                             sizeof(sdn),
		                             &junk,
		                             NULL);
		if (!ret) {
			BOOST_THROW_EXCEPTION(Win32Exception());
		}
	}

public:
	StorageDeviceNumber(wchar_t drive_letter)
	{
		wchar_t const device_name[] = {L'\\', L'\\', L'.', L'\\', drive_letter, L':', L'\0'};
		create(device_name);

	}

	StorageDeviceNumber(std::wstring const &device_name)
	{
		create(device_name.c_str());
	}

	unsigned int getDeviceType() const
	{
		return this->DeviceType;
	}

	unsigned int getDeviceNumber() const
	{
		return this->DeviceNumber;
	}

	unsigned int getPartitionNumber() const
	{
		return this->PartitionNumber;
	}
};
};  // namespace MyLib
